#include <stdio.h>
#include <stdlib.h>

#define INF (-1)
#define TRUE 1
#define FALSE 0

typedef struct veza
{
	int u;
	int v;
	int l;
	int brVojnika;
} veza;

int **a, *pripadnost, *stablo, n, m, p, q;
veza *veze;

void spojSkupove(int u, int v)
{
	int i, pom = pripadnost[u];
	
	for(i = 0; i < n; i++)
		if(pripadnost[i] == pom)
			pripadnost[i] = pripadnost[v];
}

main()
{
	int i, j;
	
	scanf("%d%d", &n, &m);
	
	a = (int **)malloc(n * sizeof(int*));
	for(i = 0; i < n; i++)
		a[i] = (int *)malloc(n * sizeof(int));
		
	pripadnost = (int*)malloc(n * sizeof(int));
	stablo = (int*)malloc(m * sizeof(int));
	veze = (veza*)malloc(m * sizeof(veza));
	
	for(i = 0; i < n; i++)
		for(j = 0; j < n; j++)
			a[i][j] = INF;
			
	for(i = 0; i < n; i++)
	{
		pripadnost[i] = i;
	}
	
	for(i = 0; i < m; i++)
		stablo[i] = FALSE;
		
	for(i = 0; i < m; i++)
	{
		int u, v, l;
		scanf("%d%d%d", &u, &v, &l);
		u--; v--;
		a[u][v] = a[v][u] = l;
		veze[i].u = u;
		veze[i].v = v;
		veze[i].l = l;
		veze[i].brVojnika = 0;
	}
	
	scanf("%d%d", &p, &q);
	
	for(i = 0; i < m; i++)
	{
		int duzina = veze[i].l, br;
		br = duzina / p;
		
		if(duzina % 2 == 0)
			br--;
			
		br *= q;
		
		if(br < 0)
			br = 0;
		
		veze[i].brVojnika = br;
	}
	
	for(i = 0; i < m - 1; i++)
		for(j = i + 1; j < m; j++)
			if(veze[i].brVojnika > veze[j].brVojnika)
			{
				veza t = veze[i];
				veze[i] = veze[j];
				veze[j] = t;
			}
			
	int vojnici = 0, trenutna = 0, brUvrstenih = 0;
	
	while(brUvrstenih < n - 1)
	{
		if(pripadnost[veze[trenutna].u] != pripadnost[veze[trenutna].v])
		{
			spojSkupove(veze[trenutna].u, veze[trenutna].v);
			stablo[trenutna] = TRUE;
			vojnici += veze[trenutna].brVojnika;
			brUvrstenih++;
		}
		trenutna++;
	}
	
	/*for(i = 0; i < m; i++)
		if(stablo[i] == TRUE)
			printf("Veza (%d, %d) = %d i vojnici %d\n", veze[i].u + 1, veze[i].v + 1, veze[i].l, veze[i].brVojnika);
	*/
			
	printf("%d\n", vojnici);
}
