#include<stdio.h>
#include<stdlib.h>

#define TRUE 1
#define FALSE 0
#define S 1
#define Q 0
#define INF (-1)
#define NEDEFINISANO (-1)

int n,l, **graf, *pret, *flag, *duzina, P, V;
int pocetak = 0;

int jeManji(int x, int y)
{
	if(x == INF)
		return FALSE;
	if(y == INF)
		return TRUE;
	
	return x<y;
}

int nadjiMinimum()
{
	int i, min = INF, minCvor = NEDEFINISANO;
	
	for(i = 0; i < n; i++)
	{
		if(jeManji(duzina[i], min) && flag[i] == Q)
		{
			min = duzina[i];
			minCvor = i;
		}
	}
	
	return minCvor;
}

void ispis(int i)
{
	if(i == pocetak)
		printf("%d   ", i);
	else if(pret[i] == NEDEFINISANO)
		printf("Kraj");
	else
	{
		ispis(pret[i]);
		printf("%d   ", i);
	}
}

main()
{
	int i, j, min;
	
	
	scanf("%d%d", &n, &l);
	
	graf = (int **)malloc(n * sizeof(int *));
	for(i = 0; i < n; i++)
		graf[i] = (int *)malloc(n * sizeof(int));
	
	pret = (int *)malloc(n * sizeof(int ));
	flag = (int *)malloc(n * sizeof(int ));
	duzina = (int *)malloc(n * sizeof(int ));
	
	for(i = 0; i < n; i++)
	{
		pret[i] = NEDEFINISANO;
		flag[i] = Q;
		duzina[i] = INF;
	}
	
	for(i = 0; i < n; i++)
		for(j = 0; j < n; j++)
			graf[i][j] = INF;
			
	for(i = 0; i < l; i++)
	{
		int u,v,w;
		scanf("%d%d%d", &u, &v, &w);
		u--;
		v--;
		
		graf[u][v] = graf[v][u] = w;
	}
	
	scanf("%d%d", &P, &V);
	
	duzina[pocetak] = 0;
	int vojnici = 0;
	
	for(i = 0; i < n; i++)
	{
		
		min = nadjiMinimum();
		printf("%d\n", min);
		flag[min] = S;
		
		if(min != pocetak)
		{
			vojnici += duzina[min];
		}
		
		for(j = 0; j < n; j++)
		{
			if(graf[min][j] != INF && flag[j] == Q &&jeManji(((graf[min][j] - 1) / P) * V, duzina[j]))
			{
				if((graf[min][j] - 1) <= 1)
				{
					duzina[j] = 0;
					pret[j] = min;
				}
				else
				{
					duzina[j] = ((graf[min][j] - 1) / P) * V;
					pret[j] = min;
				}
			}
		}
	}
	
	for(i = 0; i < n; i++)
		printf("%d   ", duzina[i]);
	
	printf("\n%d\n", vojnici);
	ispis(8);
}




